/*
 * vim: ts=4 nobackup
 */


#include "Chronometer.H"
#include <avr/io.h>
#include <avr/interrupt.h>


using namespace std;
using namespace avelino;


volatile uint32_t Chronometer::microseconds;
volatile uint32_t Chronometer::microseconds2;


bool Chronometer::initialized = false;


void Chronometer::init() {
	if (initialized)
		return;
	microseconds = 0;
	microseconds2 = 0;
	cli();
	TCCR1A = 0;
	TCCR1B = 0;
	OCR1A = 9;
	TCNT1 = 0;
	TCCR1B |= ((1 << WGM12) | (1 << CS11));
	TIMSK1 = (1 << OCIE1A);
	sei();
	initialized = true;
}


void Chronometer::__isr() {
	microseconds += 5;
	microseconds2 += 5;
}


ISR(TIMER1_COMPA_vect) {
	Chronometer::__isr();
}
