/*
 * vim: ts=4 nobackup
 */


#include "RPMReader.H"
#include "Chronometer.H"
#include <avr/io.h>
#include <avr/interrupt.h>


using namespace std;
using namespace avelino;


float RPMReader::rpm;


void RPMReader::init() {
	DDRD &= 0xFE;    // PD0 as input
	cli();
	EICRA = (1 << ISC01) | (1 << ISC00);    // external INT0 (PD0 / pin 3 on Arduino Leonardo)
	EIMSK = (1 << INT0);
	sei();
	Chronometer::init();
	Chronometer::microseconds = 0;
}


void RPMReader::__isr() {
	uint32_t delta = Chronometer::microseconds;
	Chronometer::microseconds = 0;
	if (delta > 0)
		rpm = (((float) 1) / delta) * 60000000;
	EIFR |= (1 << INTF0);
}


ISR(INT0_vect) {
	RPMReader::__isr();
}

