/*
 * vim: ts=4 nobackup
 */


#ifndef  __VECTOR_H__
#define  __VECTOR_H__


extern "C++" {
	namespace avelino {
		template <typename T>
		class Vector {
			public:
				static const uint8_t MAX_VECTOR_SIZE = 10;
				T values[MAX_VECTOR_SIZE];
				uint8_t size;
				Vector();
				void add(T v);
				bool exists(T v);
		};

		template <typename T>
		Vector<T>::Vector() {
			this->size = 0;
		}

		template <typename T>
		void Vector<T>::add(T v) {
			this->values[this->size] = v;
			this->size++;
		}

		template <typename T>
		bool Vector<T>::exists(T v) {
			T *p = this->values;
			for (uint8_t i = 0; i < this->size; i++, p++) {
				if (*p == v)
					return true;
			}
			return false;
		}
	}
}


#endif  // __VECTOR_H__
